'
'	"FPU.inc"
'This file is #Included inline in "DisAsm.bas"
'

	mn = "F"
	cb3 = Asc(s, ip + n + 1)
	sr = rr : de = rm

	If cb1 = &H9B Then
		mn = "FWAIT: " : de = (cb3\8) And 7 : Incr n

		Select Case cb2

			Case &HD9

				If de = 6 Then
					mn = mn & "FSTENV" : dt = %m1428Byte

				ElseIf de = 7 Then
					mn = mn & "FSTCW" : dt = %m2byte

				End If

			Case &HDB

				If cb3 = &HE2 Then
					mn = mn & "FCLEX"

				ElseIf cb3 = &HE3 Then
					mn = mn & "FINIT"

				End If

			Case &HDD

				If de = 6 Then
					mn = mn & "FSAVE" : dt = %m94108Byte

				ElseIf de = 7 Then
					mn = mn & "FSTSW" : dt = %m2byte 'Case &HDD /7 ; "fstsw" %m2byte

				End If

			Case &HE0
				mn = mn & "FSTSW AX" ': dt = %AX	   'Case &HDF E0 ; "fstsw" AX

			Case Else
				Decr n

		End Select

	ElseIf cb1 = &HD8 Then
		de = ((cb2\8) And 7) + 1
		st = Asc($D8a, de)
		sr = cb2 And 7 'get register number
		mn = mn & Choose$(de, "ADD", "MUL", _
		"COM", "COMP", "SUB", "SUBR", "DIV", "DIVR")

		'dt = %RegMem '%m32fp
		'&HC0 +i ; "fadd" ST(0),ST(i)
		'&HC8 +i ; "fmul" ST(0),ST(i)
		'&HD0 +i ; "fcom" ST(i)
		'&HD1	 ; "fcom"
		'&HD8 +i ; "fcomp" ST(i)
		'&HD9	 ; "fcomp"
		'&HE0 +i ; "fsub" ST(0),ST(i)
		'&HE8 +i ; "fsubr" ST(0),ST(i)
		'&HF0 +i ; "fdiv" ST(0),ST(i)
		'&HF8 +i ; "fdivr" ST(0),ST(i)

	ElseIf cb1 = &HD9 Then
		'these have implied operands
		de = InStr($D9, Chr$(cb2))

		If cb2 => &HF0 Then
			mn = mn & Choose$(cb2 - &HEF, "2XM1", "YL2X", "PTAN", "PATAN", _
			"XTRACT", "PREM1", "DECSTP", "INCSTP", "PREM", "YL2XP1", _
			"SQRT", "SINCOS", "RNDINT", "SCALE", "SIN", "COS")
			Incr n

			'&HF0 ; "f2xm1"
			'&HF1 ; "fyl2x"
			'&HF2 ; "fptan"
			'&HF3 ; "fpatan"
			'&HF4 ; "fxtract"
			'&HF5 ; "fprem1"
			'&HF6 ; "fdecstp"
			'&HF7 ; "fincstp"
			'&HF8 ; "fprem"
			'&HF9 ; "fyl2xp1"
			'&HFA ; "fsqrt"
			'&HFB ; "fsincos"
			'&HFC ; "frndint"
			'&HFD ; "fscale"
			'&HFE ; "fsin"
			'&HFF ; "fcos"

		ElseIf (cb2 => &HC0) And (cb2 <= &HCF) Then
			mn = mn & IIf$(cb2 < &HC8, "LD", "XCH")

			'&HC0 +i ; "fld" ST(i)
			'&HC8 +i ; "fxch" ST(i)
			'&HC9 ; "fxch"
			'If sr < &HC9 Then
			st = %St0Sti : sr = cb2 And 7

		ElseIf de Then 'de = Instr($D9, Chr$(Cb2))
			'these have implied operands
			mn = mn & Choose$(de, "NOP", "CHS", "ABS", "TST", "XAM", _
			"LD1", "LDL2T", "LDL2E", "LDPI", "LDLG2", "LDLN2", "LDZ")
			Incr n

			'&HD0 ; "fnop"
			'&HE0 ; "fchs"
			'&HE1 ; "fabs"
			'&HE4 ; "ftst"
			'&HE5 ; "fxam"
			'&HE8 ; "fld1"
			'&HE9 ; "fldl2t"
			'&HEA ; "fldl2e"
			'&HEB ; "fldpi"
			'&HEC ; "fldlg2"
			'&HED ; "fldln2"
			'&HEE ; "fldz"

		Else
			mn = mn & Choose$(sr + 1, "LD", "???", "ST", _
			"STP", "LDENV", "LDCW", "NSTENV", "NSTCW")

			Select Case sr
				Case 0 : st = %m32fp
				Case 4 : st = %m1428Byte
				Case 5 : st = %m2byte
				Case 6 : dt = %m1428Byte
				Case 7 : dt = %m2byte
				Case Else : dt = %m32fp '2 or 3

			End Select

			'/0 ; "fld" m32fp
			'/2 ; "fst" m32fp
			'/3 ; "fstp" m32fp
			'/4 ; "fldenv" m14/28Byte
			'/5 ; "fldcw" m2byte
			'/6 ; "fnstenv" m14/28Byte
			'/7 ; "fnstcw" m2byte

		End If

	ElseIf cb1 = &HDA Then

		If (cb2 => &HC0) And (sr <= &HD8) Then
			mn = mn & "CMOV" & Choose$(((cb2\8) And 3) + 1, "B", "E", "BE", "U")
			st = %St0Sti : sr = cb2 And 7

			'&HC0 +i ; "fcmovb" ST(0),ST(i)
			'&HC8 +i ; "fcmove" ST(0),ST(i)
			'&HD0 +i ; "fcmovbe" ST(0),ST(i)
			'&HD8 +i ; "fcmovu" ST(0),ST(i)

		ElseIf cb2 = &HE9 Then
			mn = mn & "UCOMPP" : Incr n
			'&HE9 ; "fucompp"

		Else
			mn = mn & Choose$(sr + 1, "IADD", "IMUL", _
			"ICOM", "ICOMP", "ISUB", "ISUBR", "IDIV", "IDIVR")
			st = %m32int

			' /0 ; "fiadd" m32int
			' /1 ; "fimul" m32int
			' /2 ; "ficom" m32int
			' /3 ; "ficomp" m32int
			' /4 ; "fisub" m32int
			' /5 ; "fisubr" m32int
			' /6 ; "fidiv" m32int
			' /7 ; "fidivr" m32int

		End If

	ElseIf cb1 = &HDB Then
		de = InStr($DB, Chr$(cb2 And &HF8))

		If cb2 = &HE2 Then
			mn = "FNCLEX" : Incr n

			'&HE2  1110 0010
			'&HE2 ; "FNCLEX"

		ElseIf cb2 = &HE3 Then
			mn = "FNINIT" : Incr n

			'&HE3  1110 0011
			'&HE3 ; "FNINIT"

		ElseIf de Then
			mn = mn & Choose$(de, "CMOVNB", "CMOVNE", _
			"CMOVNBE", "CMOVNU", "UCOMI", "COMI")
			st = %St0Sti : sr = cb2 And 7

			'&HC0  1100 0000
			'&HC8  1100 1000
			'&HD0  1101 0000
			'&HD8  1101 1000
			'&HE8  1110 1000
			'&HF0  1111 0000
			'&HC0 +i ; "fcmovnb" ST(0),ST(i)
			'&HC8 +i ; "fcmovne" ST(0),ST(i)
			'&HD0 +i ; "fcmovnbe" ST(0),ST(i)
			'&HD8 +i ; "fcmovnu" ST(0),ST(i)
			'&HE8 +i ; "fucomi" ST,ST(i)
			'&HF0 +i ; "fcomi" ST,ST(i)

		Else
			mn = mn & Choose$(sr + 1, "ILD", "???", _
			"IST", "ISTP", "???", "LD", "???", "STP")

			If (sr = 5) Or (sr = 7) Then
				st = %m80fp
			ElseIf (sr = 0) Or (sr = 2) Or (sr = 3) Then
				st = %m32int
			End If

			' /0 ; "fild" m32int
			' /2 ; "fist" m32int
			' /3 ; "fistp" m32int
			' /5 ; "fld" m80fp
			' /7 ; "fstp" m80fp

		End If

	ElseIf cb1 = &HDC Then
		de = InStr($DC, Chr$(cb2 And &HF8))

		If de Then
			mn = mn & Choose$(de, "ADD", "MUL", "SUBR", "SUB", "DIVR", "DIV")
			dt = %StiSt0 : de = cb2 And 7

			'&HC0 +i ; "fadd" ST(i),ST(0)
			'&HC8 +i ; "fmul" ST(i),ST(0)
			'&HE0 +i ; "fsubr" ST(i),ST(0)
			'&HE8 +i ; "fsub" ST(i),ST(0)
			'&HF0 +i ; "fdivr" ST(i),ST(0)
			'&HF8 +i ; "fdiv" ST(i),ST(0)

		Else
			mn = mn & Choose$(sr + 1, "ADD", "MUL", _
			"COM", "COMP", "SUB", "SUBR", "DIV", "DIVR")
			st = %m64fp

			'/0 ; "fadd" m64fp
			'/1 ; "fmul" m64fp
			'/2 ; "fcom" m64fp
			'/3 ; "fcomp" m64fp
			'/4 ; "fsub" m64fp
			'/5 ; "fsubr" m64fp
			'/6 ; "fdiv" m64fp
			'/7 ; "fdivr" m64fp

		End If

	ElseIf cb1 = &HDD Then
		de = InStr($DD, Chr$(cb2 And &HF8))

		If de Then
			mn = mn & Choose$(de, "FREE", "ST", "STP", "UCOM", "UCOMP")
			st = %St0Sti : sr = cb2 And 7

			'removed the implied destination instructions
			'&HC0 +i ; "ffree" ST(i)
			'&HD0 +i ; "fst" ST(i)
			'&HD8 +i ; "fstp" ST(i)
			'&HE0 +i ; "fucom" ST(i)
			'&HE8 +i ; "fucomp" ST(i)
			'&HC0 +i ; "ffree" ST(i)
			'&HD0 +i ; "fst" ST(i)
			'&HD8 +i ; "fstp" ST(i)
			'&HE0 +i ; "fucom" ST(i)
			'&HE1 ; "fucom"
			'&HE8 +i ; "fucomp" ST(i)
			'&HE9 ; "fucomp"

		Else
			mn = mn & Choose$(sr + 1, "LD", "???", _
			"ST", "STP", "RSTOR", "???", "NSAVE", "NSTSW")

			If (sr = 0) Or (sr = 2) Or (sr = 3) Then
				st = %m64fp

			ElseIf (sr = 4) Or (sr = 6) Then
				st = %m94108Byte

			ElseIf (sr = 7) Then
				st = %m2byte

			End If

			'/0 ; "fld" m64fp
			'/2 ; "fst" m64fp
			'/3 ; "fstp" m64fp
			'/4 ; "frstor" m94/108Byte
			'/6 ; "fnsave" m94/108Byte
			'/7 ; "fnstsw" m2byte

		End If

	ElseIf cb1 = &HDE Then
		de = InStr($DE, Chr$(cb2 And &HF8))

		If cb2 = &HD9 Then
			mn = "FCOMPP" : Incr n

		ElseIf de Then
			mn = mn & Choose$(de, "ADDP", "MULP", "SUBRP", "SUBP", "DIVRP", "DIVP")
			dt = %StiSt0 : de = cb2 And 7

			'&HC0 +i ; "faddp" ST(i),ST(0)
			'&HC8 +i ; "fmulp" ST(i),ST(0)
			'&HE0 +i ; "fsubrp" ST(i),ST(0)
			'&HE8 +i ; "fsubp" ST(i),ST(0)
			'&HF0 +i ; "fdivrp" ST(i),ST(0)
			'&HF8 +i ; "fdivp" ST(i),ST(0)
			'&HC0 +i ; "faddp" ST(i),ST(0)
			'&HC1 ; "faddp"
			'&HC8 +i ; "fmulp" ST(i),ST(0)
			'&HC9 ; "fmulp"
			'&HE0 +i ; "fsubrp" ST(i),ST(0)
			'&HE1 ; "fsubrp"
			'&HE8 +i ; "fsubp" ST(i),ST(0)
			'&HE9 ; "fsubp"
			'&HF0 +i ; "fdivrp" ST(i),ST(0)
			'&HF1 ; "fdivrp"
			'&HF8 +i ; "fdivp" ST(i),ST(0)
			'&HF9 ; "fdivp"

		Else
			mn = mn & Choose$(sr + 1, "IADD", "IMUL", _
			"ICOM", "ICOMP", "ISUB", "ISUBR", "IDIV", "IDIVR")
			st = %m16int

			'/0 ; "fiadd" m16int
			'/1 ; "fimul" m16int
			'/2 ; "ficom" m16int
			'/3 ; "ficomp" m16int
			'/4 ; "fisub" m16int
			'/5 ; "fisubr" m16int
			'/6 ; "fidiv" m16int
			'/7 ; "fidivr" m16int

		End If

	ElseIf cb1 = &HDF Then
		de = cb2 And 7

		If cb2 = &HE0 Then
			mn = "FNSTSW AX" : Incr n ': dt = %AX

		ElseIf cb2 = &HE8 Then
			mn = "FUCOMIP" : sr = de : st = %St0Sti
			'&HE8 +i ; "FUCOMIP" ST,ST(i)

		ElseIf cb2 = &HF0 Then
			mn = "FCOMIP" : sr = de : st = %St0Sti
			'&HF0 +i ; "FCOMIP" ST,ST(i)

		Else
			mn = mn & Choose$(sr + 1, "ILD", "???", _
			"IST", "ISTP", "BLD", "ILD", "BSTP", "ISTP")

			If (sr = 0) Or (sr = 2) Or (sr = 3) Then
				st = %m16int

			ElseIf (sr = 4) Or (sr = 6) Then
				st = %m80bcd

			ElseIf (sr = 5) Or (sr = 7) Then
				st = %m64int

			End If

			'/0 ; "fild" m16int
			'/2 ; "fist" m16int
			'/3 ; "fistp" m16int
			'/4 ; "fbld" m80dec
			'/5 ; "fild" m64int
			'/6 ; "fbstp" m80bcd
			'/7 ; "fistp" m64int

		End If

	Else
		'msgbox hex$(cb1) & hex$(cb2) & " not found'

	End If

	'
