'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'   "Analyse.inc"
'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>

Function LoadVars(    _
    Lst() As String,  _
    Tar   As String,  _
    Ima   As String,  _
    Exa   As String   _
    ) As Long

#Register All
Local ff As Long
Local n  As Long

    Function = 1

    '----------------------------------
    ff = FreeFile
    Open $TarAddr For Binary As #ff
    Get$ #ff, Lof(ff), Tar
    Close# ff

    '----------------------------------
    Open $Imports For Binary As #ff
    Get$ #ff, Lof(ff), Ima
    Close# ff

    '----------------------------------
    Open $Exports For Binary As #ff
    Get$ #ff, Lof(ff), Exa
    Close# ff

    '----------------------------------
    Open $Listing For Binary As #ff
    Get$ ff, Lof(ff), s
    n = ParseCount(s, $CrLf)
    If n Then ReDim Lst(n - 1) Else Exit Function
    Parse s, Lst(), $CrLf
    Reset s
    Close# ff

    Function = 0

End Function 'LoadArrays

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'finds PUSH-es to label as API call parameters
Sub ApplyApiData(    _
    Lst() As String, _
    ByVal i As Long, _
    nm As String)

Static ff   As Long     'use it as a flag too
Local d     As Long     'depth of PUSH/POP
Local n     As Long     'parameter counter
Local p     As Long     'number of parameters
Local s     As String
Local t     As String
Static Api  As String   'Win32API data

    '----------------------------------
    If ff = 0 Then
        ff = FreeFile
        If Len(Dir$($Api)) Then
            Open $Api For Binary As #ff
            Get$ #ff, Lof(ff), Api
            Close# ff
        Else
            Exit Sub
        End If
    End If

    '----------------------------------
    s = $Lf & Mid$(nm, InStr(nm, ".") + 1)
    If Right$(s, 1) = "A" Then s = Left$(s, Len(s) -1)
    s = Extract$(Remain$(Api, s & $Tab), $Cr)
    If Len(s) = 0 Then Exit Sub

    '----------------------------------
    p = ParseCount(s, ",") : Incr n
    For i = i To 0 Step -1

        If Left$(Lst(i), 4) = $Tab & "RET" Then Exit For 'don't go past a RET

        If Left$(Lst(i), 5) = $Tab & "POP " Then Decr d

        If Left$(Lst(i), 6) = $Tab & "PUSH " Then
            Incr d
            If d => n Then
                t = Parse$(s, d)

                If Left$(t, 1) = "@" Then
                    t = Mid$(t, 2) & " Ptr"
                ElseIf Right$(t, 1) = "~" Then
                    t = Left$(t, Len(t) - 1) & " As Asciiz"
                End If

                Lst(i) = Lst(i) & $Tab & t
                If n => p Then Exit For
                n = d
            End If

        End If

    Next i

End Sub 'ApplyApiData

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>

Function AnalyseCode() As Long
#Register All
Local a  As Long
Local n  As Long
Local ub As Long
Local s  As String
Local fo As Long

Local  Tar   As String 'target addresses
Local  Ima   As String 'import addresses
Local  Exa   As String 'export addresses
Dim Lst()    As String : ReDim Lst(0) 'asm listing

    Function = 1

    '----------------------------------
    'prepare variables
    If LoadVars(Lst(), Tar, Ima, Exa) Then Exit Function
    ub = UBound(Lst)

    '----------------------------------
    'Do analysis
    Do

        '------------------------------
        'see if it's a call to an import
        s = Extract$(Remain$(Lst(a), "CALL DWORD PTR [00"), "]")
        If Len(s) Then s = Remain$(Ima, $Lf & s)
        If Len(s) Then
            s = Extract$(Remain$(s, $Tab), $Cr)
            ApplyApiData(Lst(), a - 1, s)
            Lst(a) = Lst(a) & " " & s
        End If

        '------------------------------
        'see if it's the entry of an export
        s = Left$(Lst(a), 7)
        n = IIf&(Len(s), InStr(Exa, s), 0)
        If n Then
            s = Extract$(Mid$(Exa, n + Len(s)), ".")
            Incr ub
            ReDim Preserve Lst(ub)
            Array Insert Lst(a), $CrLf & s & ": (Export)"
            Incr a
        End If

        '------------------------------
        'see if instruction is the target of a call or jump
        s = Left$(Lst(a), 6)
        If (Len(s)) And (Left$(s, 1) <> "'") And (InStr(Tar, s)) Then
            'insert a line with a label made from the address
            Incr ub
            ReDim Preserve Lst(ub)
            Array Insert Lst(a), $CrLf & "L" & s & ":"
            Incr a
        End If

        '------------------------------
        'remove address and opcodes from the line
        If (Len(Lst(a))) And (Left$(Lst(a), 1)) <> "'" Then

            'remove address
            Lst(a) = Mid$(Lst(a), 7)

            'remove opcodes
            n = InStr(Lst(a), " ")          'find first space following opcodes

            'keep the rest of the line and trim the spaces and put in a TAB
            Lst(a) = $Tab & LTrim$(Mid$(Lst(a), n))

        End If

        Incr a

    Loop While a <= ub

    '----------------------------------
    fo = FreeFile
    Open $OutFile For Output As #fo
    For a = 1 To ub
        Print# fo, Lst(a)
    Next a
    Close# fo

    Function = 0

End Function 'AnalyseCode

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
