'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'   "Decs.inc"
'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>

$Caption = "DisAsm"

Global s        As String
Global hDlg     As Dword

%Dlg       =  101
%DisBtn    = 1001
%AddrChk   = 1002
%OpcodeChk = 1003
%MnemChk   = 1004
%FileLbl   = 1100
%PathTxt   = 1101
%Rtb       = 1102
%OptFrm    = 1103


'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'for settings
Global Prefs    As Dword
Global stg      As String
Global tmp      As String

$IniFile   = "DisAsm.ini"

$Project   = "Project.txt"  'miscellaneous information
$Listing   = "Asm.txt"      'raw disassembly
$DataFile  = "Data.txt"     'data dump
$Imports   = "Imports.txt"  'imports with addresses
$Exports   = "Exports.txt"  'exports with addresses
$Rsrc      = "Rsrc.txt"
$Rloc      = "Rloc.txt"

$TarAddr   = "TarAddr.txt"  'call and jump target addresses
$OutFile   = "Out.txt"
$Api       = "Api.txt"

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'for drag and drop
%Lbl             = 1001
%ATTR_DIRECTORY  = 16

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'for section table dumper
%Export     = 1
%Import     = 2
%Resource   = 3
%BaseReloc  = 6
%Tls        = 10
%Iat        = 13
%COM        = 15

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'   for diassembler
'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'for general purpose instructions
%Implied    = 0
%ToEax      = 1 'to AL or EAX
%EaxEdx     = 2
%Reg32      = 3
%M32M32     = 4
%M16M32     = 5
%Reg        = 6
%RegMem     = 7
%Imm8_32    = 8
%Imm8       = 9
%Imm16Imm8  = 10
%Imm16      = 11
%Imm32      = 12

%R16M       = 30
%Rel8       = 31
%Rel16      = 32
%Rel32      = 33
%Rel1632    = 34
%Ptr16_32   = 35
%Moffs      = 36
%SegReg     = 38
%ByCL       = 39    'for bit-shifting instructions
%ByOne      = 40    'for bit-shifting instructions
%Stack      = 41

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'for FPU instructions:
%St0        = 50
%Sti        = 51
%St0Sti     = 52
%StiSt0     = 53
%m2byte     = 54
%m16int     = 55
%m32int     = 56
%m64int     = 57
%m32fp      = 58
%m64fp      = 59
%m1428Byte  = 60
%m94108Byte = 61
'%AX         = 62
%m80fp      = 63
'%m80dec     = 64
%m80bcd     = 65

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'for packed and SIMD instructions
%RegMem8    = 80
%RegMem16   = 81

%m8         = 82
%m32        = 83
%m64        = 84
%m512byte   = 85

%r32        = 86
%r32m16     = 87

%mm         = 90
%mm1        = 91
%mm2        = 92
%mm_m64     = 93
%mm2_m64    = 94

%xmm1       = 95
%xmm2       = 96

%xmm        = 100
%xmmm32     = 101
%xmmm64     = 102
%xmmm128    = 103
%xmm2m32    = 104
%xmm2m64    = 105
%xmm2m128   = 106
%m128       = 107
%mmm64      = 108
%rm32       = 109

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>

'flags
%Condition  = &H2000    'condition code in "tt" is valid
%DirBit     = &H0800

'$Prefix = Chr$(&H26,&H2E,&H36,&H3E,&H64,&H65,&H66,&H67,&H9B,&HF0,&HF2,&HF3)
$Prefix    = Chr$(&H9B,&HF0,&HF2,&HF3)
$Override  = Chr$(&H26,&H2E,&H36,&H3E,&H64,&H65)

'$D8 =  Chr$(&HC0,&HC8,&HD0,&HD1,&HD8,&HD9,&HE0,&HE8,&HF0,&HF8)
$D8a = Chr$(%St0Sti,%St0Sti,%Sti,%Sti,%St0Sti,%St0Sti,%St0Sti,%St0Sti)
$D9  = Chr$(&HD0,&HE0,&HE1,&HE4,&HE5,&HE8,&HE9,&HEA,&HEB,&HEC,&HED,&HEE)
$DB  = Chr$(&HC0,&HC8,&HD0,&HD8,&HE8,&HF0)
$DC  = Chr$(&HC0,&HC8,&HE0,&HE8,&HF0,&HF8)
$DD  = Chr$(&HC0,&HD0,&HD8,&HE0,&HE8)
$DE  = Chr$(&HC0,&HC8,&HE0,&HE8,&HF0,&HF8)

$OpF2 = Chr$(&H10,&H11,&H2A,&H2C,&H2D,&H51,&H58,&H59,&H5A,&H5C,&H5D,&H5E,&H5F,&H70,&HC2,&HD6,&HE6)
$OpF3 = Chr$(&H10,&H11,&H2A,&H2C,&H2D,&H51,&H52,&H53,&H58,&H59,&H5A,&H5B,&H5C,&H5D,&H5E,&H5F,&H6F,&H70,&H7E,&H7F,&HC2,&HD6,&HE6)

$Mn80       = "ADDOR ADCSBBANDSUBXORCMP"
$R8And32    = "ALCLDLBLAHCHDHBHAXCXDXBXSPBPSIDI"
$Regs       = "AXCXDXBXSPBPSIDI"

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>

%Debug      = 1

#If %Def(%Debug)

$EscBits    = Chr$(0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,15,255,0,0,12,0)
$PrefixBits = Chr$(0,0,0,0,64,64,64,64,0,0,0,0,240,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,13,0)
$NormBits   = Chr$(63,63,63,63,63,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)

Global EscBits      As String * 32
Global PrefixBits   As String * 32
Global NormBits     As String * 32

#EndIf

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'   end of disassembler declares
'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
