'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'	"Esc0F.inc"
'This file is #Included inline in "DisAsm.bas"
'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>

	cb3 = Asc(s, ip + n)
	rr = (cb3\8) And 7 : rm = cb3 And 7 : md = (cb3\64)
	wr = 1 : t3 = 0

	Select Case cb2

	'******************************************************

		Case <= &HA0
			mn = "???"

	'******************************************************

		Case <= &HA2 ' &HA0 to &HA2
			mn = Choose$(cb2 - &HBF,"PUSH FS","POP FS","CPUID")

	'******************************************************

		Case &HA3 '"bt" r/m32,r32
			mn = "BT" : dt = %RegMem : de = rm : st = %Reg : sr = rr

	'******************************************************

		Case &HA4 ' "shld" r/m32,r32,imm8
			mn = "SHLD" : dt = %RegMem : de = rm : st = %Reg : sr = rr

	'******************************************************

		Case &HA5 '"shld" r/m32,r32,CL
			mn = "SHLD" : dt = %RegMem : de = rm : st = %Reg : sr = rr

	'******************************************************

		Case &HA8
			mn = "PUSH GS"

	'******************************************************

		Case &HA9
			mn = "POP GS"

	'******************************************************

		Case &HAA
			mn = "RSM"

	'******************************************************

		Case &HAB '"bts" r/m32,r32
			mn = "BTS" : dt = %RegMem : de = rm : st = %Reg : sr = rr

	'******************************************************

		Case &HAC '"shrd" r/m32,r32,imm8
			mn = "SHRD" : dt = %RegMem : de = rm : st = %Reg

	'******************************************************

		Case &HAD '"shrd" r/m32,r32,CL
			mn = "SHRD" : dt = %RegMem : de = rm : st = %Reg

	'******************************************************

		Case &HAE

			Select Case (cb3\8) And 7
				Case 0
					mn = "FXSAVE"
					dt = %m512byte : de = rm
				Case 1
					mn = "FXRSTOR"
					st = %m512byte : sr = rm
				Case 3
					mn = "STMXCSR"
					dt = %m32 : de = rm
				Case 5
					mn = "LFENCE"
					Incr n
				Case 6
					mn = "MFENCE"
					Incr n
				Case 7
					mn = "CLFLUSH"
					dt = %m8 : de = rm
				Case 7
					mn = "SFENCE"
					Incr n
			End Select


	'******************************************************

		Case &HAF '/r ; "imul" r32,r/m32
			mn = "IMUL"
			dt = %Reg : de = rr : st = %RegMem : sr = rm

	'******************************************************

		Case <= &HB1 '&HB0 to &HB1	/r ; "cmpxchg" r/m8-32,r8-32
			mn = "CMPXCHG"
			wr = (cb2 And 1)
			dt = %RegMem : de = rm : st = %Reg : sr = rm

	'******************************************************

		Case &HB3	'"btr" r/m16,r16
			mn = "BTR"
			dt = %RegMem : de = rm : st = %Reg : sr = rm

	'******************************************************

		Case <= &HB5 '&HB2 To &HB5 except &HB3	   /r ; "lgs" r32,m16:32
			mn = "L" & Mid$("SFG", cb2 - &HB1, 1) & "S"
			dt = %Reg : de = rr : st = %RegMem : sr = rm

	'******************************************************
		Case <= &HB7	'/r ; "movzx" r16,r/m8
			mn = "MOVZX" : wr = 1 : dt = %Reg : de = rr
			st = IIf&((cb2 And 1), %RegMem16, %RegMem8) : sr = rm

		'&HB6 /r ; "movzx" r16,r/m8
		'&HB6 /r ; "movzx" r32,r/m8
		'&HB7 /r ; "movzx" r32,r/m16

	'******************************************************

		Case &HBA	'/4 ib ; "bt" through "btc" 	r/m16,imm8
			mn = "BT" & Mid$(" SRC", rr + 1, 1)
			dt = %RegMem : de = rm : st = %Imm8

		'/4 ib ; "bt" r/m16,imm8
		'/4 ib ; "bt" r/m32,imm8
		'/5 ib ; "bts" r/m16,imm8
		'/5 ib ; "bts" r/m32,imm8
		'/6 ib ; "btr" r/m16,imm8
		'/6 ib ; "btr" r/m32,imm8
		'/7 ib ; "btc" r/m16,imm8
		'/7 ib ; "btc" r/m32,imm8

	'******************************************************

		Case &HBB
			mn = "BTC"
			dt = %RegMem : de = rm : st = %Reg : sr = rr

		'&HBB ; "btc" r/m16,r16
		'&HBB ; "btc" r/m32,r32
	'******************************************************

		Case <= &HBD
			mn = "BS" & Mid$("FR", cb2 - &HBB, 1)
			dt = %Reg : de = rr : st = %RegMem : sr = rm

		' &HBC ; "bsf" r16,r/m16
		' &HBC ; "bsf" r32,r/m32
		' &HBD ; "bsr" r16,r/m16
		' &HBD ; "bsr" r32,r/m32
	'******************************************************

		Case <= &HBD   '/r ; "movsx" r16,r/m8
			mn = "MOVSX"
			dt = %Reg : de = rr
			st = IIf&((cb2 And 1), %RegMem16, %RegMem8) : sr = rm

		'&HBE /r ; "movsx" r16,r/m8
		'&HBE /r ; "movsx" r32,r/m8
		'&HBF /r ; "movsx" r32,r/m16
	'******************************************************

		Case <= &HC1	'/r ; "xadd" r/m8,r8
			mn = "XADD" : wr = (cb2 And 1)
			dt = %RegMem : de = rm : st = %Reg : sr = rr

		'&HC0 /r ; "xadd" r/m8,r8
		'&HC1 /r ; "xadd" r/m16,r16
		'&HC1 /r ; "xadd" r/m32,r32

	'******************************************************

		Case <= &HC8
			cb2 = cb2 - &HC1
			mn = Choose$(cb2,"CMPPS","MOVNI", "PINSRW", _
				"PEXTRW","SHUFPS","CMPXCHG8B","BSWAP")


			dt = Choose(cb2,%xmm1,%m32,%mm,%r32,%xmm1,%m64,%r32)
			st = Choose(cb2,%xmm2m128,%r32,%r32m16,%mm,%xmm2m128,%Implied,%Implied)
			t3 = Choose(cb2,%Imm8,%Implied,%Imm8,%Imm8,%Imm8,%Implied,%Implied)

		 '&HC2 /r ib ; "cmpps" xmm1,xmm2/m128,imm8
		 '&HC3 /r ; "movni" m32,r32
		 '&HC4 /r ib ; "pinsrw" mm,r32/m16,imm8
		 '&HC5 /r ib ; "pextrw" r32,mm,imm8
		 '&HC6 /r ib ; "shufps" xmm1,xmm2/m128,imm8
		 '&HC7 /1 m64 ; "cmpxchg8b" m64
		 '&HC8 +rd ; "bswap" r32

	'******************************************************

		Case < &HD1
			mn = "???"

	'******************************************************

		Case <= &HFE '&HD1 to &HFE
			cb2 = cb2 - &HD0
			mn = Choose$(cb2, _
				"PSRLW","PSRLD","PSRLQ","PADDQ","PMULLW","???","PMOVMSKB",	_
				"PSUBUSB","PSUBUSW","PMINUB","PAND","PADDUSB","PADDUSW",	_
				"PMAXUB","PANDN","PAVGB","PSRAW","PSRAD","PAVGW","PMULHUW", _
				"PMULHW","???","MOVNTQ","PSUBSB","PSUBSW","PMINSW","POR",	_
				"PADDSB","PADDSW","PMAXSW","PXOR","???","PSLLW","PSLLD",	_
				"PSLLQ","PMULUDQ","PMADDWD","PSADBW","MASKMOVQ","PSUBB",	_
				"PSUBW","PSUBD","PSUBQ","PADDB","PADDW","PADDD")

			dt = Choose(cb2, _
				%mm,%mm,%mm,%mm1,%mm,%Implied,%r32,%mm,%mm,%mm1,%mm,%mm,%mm,%mm1,	_
				%mm,%mm1,%mm,%mm,%mm1,%mm1,%mm,%Implied,%m64,%mm,%mm,%mm1,%mm,%mm,	_
				%mm,%mm1,%mm,%Implied,%mm,%mm,%mm,%mm1,%mm,%mm1,%mm1,%mm,%mm,%mm,	_
				%mm1,%mm,%mm,%mm)

			de = IIf(cb2 <> &HE7, rr, rm)

			st = Choose(cb2, _
				%mm_m64,%mm_m64,%mm_m64,%mm2_m64,%mm_m64,%Implied,%mm,%mm_m64,		_
				%mm_m64,%mm2_m64,%mm_m64,%mm_m64,%mm_m64,%mm2_m64,%mm_m64,%mm2_m64, _
				%mm_m64,%mm_m64,%mm2_m64,%mm2_m64,%mm_m64,%Implied,%mm,%mm_m64, 	_
				%mm_m64,%mm2_m64,%mm_m64,%mm_m64,%mm_m64,%mm2_m64,%mm_m64,%Implied, _
				%mm_m64,%mm_m64,%mm_m64,%mm2_m64,%mm_m64,%mm2_m64,%mm2,%mm_m64, 	_
				%mm_m64,%mm_m64,%mm2_m64,%mm_m64,%mm_m64,%mm_m64)

			If (cb2 = &HD7) Or (cb2 = &HE7) Then sr = rr Else sr = rm

			' &HD1 /r ; "psrlw" mm,mm/m64
			' &HD2 /r ; "psrld" mm,mm/m64
			' &HD3 /r ; "psrlq" mm,mm/m64
			' &HD4 /r ; "paddq" mm1,mm2/m64
			' &HD5 /r ; "pmullw" mm,mm/m64
			' &H00 /r ; "???"	 mm,mm/m64

			' &HD7 /r ; "pmovmskb" r32,mm

			' &HD8 /r ; "psubusb" mm,mm/m64
			' &HD9 /r ; "psubusw" mm,mm/m64
			' &HDA /r ; "pminub" mm1,mm2/m64
			' &HDB /r ; "pand" mm,mm/m64
			' &HDC /r ; "paddusb" mm,mm/m64
			' &HDD /r ; "paddusw" mm,mm/m64
			' &HDE /r ; "pmaxub" mm1,mm2/m64
			' &HDF /r ; "pandn" mm,mm/m64
			' &HE0 /r ; "pavgb" mm1,mm2/m64
			' &HE1 /r ; "psraw" mm,mm/m64
			' &HE2 /r ; "psrad" mm,mm/m64
			' &HE3 /r ; "pavgw" mm1,mm2/m64
			' &HE4 /r ; "pmulhuw" mm1,mm2/m64
			' &HE5 /r ; "pmulhw" mm,mm/m64
			' &H00 /r ; "???" mm,mm/m64

			' &HE7 /r ; "movntq" m64,mm

			' &HE8 /r ; "psubsb" mm,mm/m64
			' &HE9 /r ; "psubsw" mm,mm/m64
			' &HEA /r ; "pminsw" mm1,mm2/m64
			' &HEB /r ; "por" mm,mm/m64
			' &HEC /r ; "paddsb" mm,mm/m64
			' &HED /r ; "paddsw" mm,mm/m64
			' &HEE /r ; "pmaxsw" mm1,mm2/m64
			' &HEF /r ; "pxor" mm,mm/m64
			' &H00 /r ; "???"  mm,mm/m64
			' &HF1 /r ; "psllw" mm,mm/m64
			' &HF2 /r ; "pslld" mm,mm/m64
			' &HF3 /r ; "psllq" mm,mm/m64
			' &HF4 /r ; "pmuludq" mm1,mm2/m64
			' &HF5 /r ; "pmaddwd" mm,mm/m64
			' &HF6 /r ; "psadbw" mm1,mm2/m64

			' &HF7 /r ; "maskmovq" mm1,mm2

			' &HF8 /r ; "psubb" mm,mm/m64
			' &HF9 /r ; "psubw" mm,mm/m64
			' &HFA /r ; "psubd" mm,mm/m64
			' &HFB /r ; "psubq" mm1,mm2/m64
			' &HFC /r ; "paddb" mm,mm/m64
			' &HFD /r ; "paddw" mm,mm/m64
			' &HFE /r ; "paddd" mm,mm/m64

		Case Else
			Decr n : GoTo ItsaPrefix

	End Select


	'******************************************************
	'decode operands
	'******************************************************

	If dt Then mn = mn & " "

	Select Case dt
		Case %Implied
		Case %Reg
			If wr Then
				If oz = 0 Then mn = mn & "E"
				de = de + 8
			End If
			mn = mn & Mid$($R8And32, (de * 2) + 1, 2) '& ", "

		Case %RegMem
			GoSub DecodeRegMem

		'Case %RegMem8
		'	 mn = mn & "BYTE PTR "
		 '	 wr = 0 : GoSub DecodeRegMem

		'Case %RegMem16
		'	 mn = mn & "WORD PTR "
		'	 wr = 1 : GoSub DecodeRegMem

		Case %m8
		Case %m32
			os = "DWORD "
			wr = 1
			GoSub DecodeRegMem

		Case %m64
			os = "QWORD "
			wr = 1
			GoSub DecodeRegMem

		Case %m512byte
			os = "512BYTE "
			wr = 1
			GoSub DecodeRegMem

		Case %r32
			wr = 1
			GoSub DecodeReg

		'Case %imm8

		Case %mm
			mn = mn & "MM" & Format$(de)
		Case %mm1
			mn = mn & "MM1"
		Case %mm2
			mn = mn & "MM2"
		Case %mm_m64
		Case %mm2_m64

		Case %xmm1
			mn = mn & "XMM1"

		'Case %xmm2m128
		!' doesn't apply to any destination (so far...)

		'Case %r32m16
		!' doesn't apply to any destination (so far...)

		Case Else
			Incr db

	End Select

	'******************************************************

	If (dt) And (st) Then mn = mn & ","

	Select Case st
		Case %Implied
		Case %Reg
			mn = mn & " "
			If wr Then
				If oz = 0 Then mn = mn & "E"
				sr = sr + 8
			End If
			mn = mn & Mid$($R8And32, (sr * 2) + 1, 2)

		Case %RegMem
			mn = mn & " "
			de = sr : GoSub DecodeRegMem

		Case %RegMem8
			'mn = mn & "BYTE PTR "
			de = sr : wr = 0
			GoSub DecodeRegMem

		Case %RegMem16
			'mn = mn & "WORD PTR "
			wr = 1 : de = sr
			GoSub DecodeRegMem

		Case %m8
		Case %m32
			os = "DWORD "
			wr = 1
			de = sr : GoSub DecodeRegMem

		Case %m64
			os = "QWORD "
			wr = 1
			de = sr : GoSub DecodeRegMem

		Case %m512byte
			os = "512BYTE "
			wr = 1
			de = sr : GoSub DecodeRegMem

		Case %r32
			wr = 1
			GoSub DecodeReg

		Case %imm8

		Case %mm
			mn = mn & "MM" & Format$(de)
		Case %mm1
			mn = mn & "MM1"
		Case %mm2
			mn = mn & "MM2"
		Case %mm_m64
		Case %mm2_m64

		Case %xmm1
			mn = mn & "XMM1"

		Case %xmm2m128

		Case %r32m16 'operand size prefix (&H66) applies here
		!' still to do

		Case Else
			Incr db

	End Select

	'******************************************************

	If (dt) And (st) And (t3) Then mn = mn & ","

	Select Case t3
		Case %Implied
		Case %imm8
		Case Else
			Incr db

	End Select


	GoTo ClearPrefixes

	'******************************************************
