'
'	"Settings.inc"
'

Macro Function GetCheck(ID)
MacroTemp chk
Dim chk&
	Control Get Check hDlg, ID To chk&
End Macro = chk&

Declare Sub LoadSettings(hDlg As Dword)
Declare Sub SaveSettings(hDlg As Dword)
Declare Sub GetSettings(hDlg As Dword)

'

Sub LoadSettings(hDlg As Dword)
Local ff  As Long
Local cx  As Long 'x coordinate
Local cy  As Long 'y coordinate
Local i   As Long 'control ID
Local v   As Long 'value of numeric setting
Local t   As Asciz * 2

	If Len(Dir$($IniFile)) Then
		ff = FreeFile
		Open $IniFile For Input As #ff

		Do
			Line Input# ff, tmp
			t = Left$(tmp, 1)
			tmp = Parse$(tmp, "=", 2)
			i = Val(tmp)

			If t = "@" Then 	'it's position coordinates
				cx = Val(Parse$(tmp, $Tab, 2))
				cy = Val(Parse$(tmp, $Tab, 3))
				If i < 1000 Then
					Dialog Set Loc hDlg, cx, cy
				Else
					Control Set Loc hDlg, i, cx, cy
				End If

			ElseIf t = "$" Then 		'it's a control text
				Control Set Text hDlg, i, Parse$(tmp, $Tab, 2)	'apply setting

			ElseIf t = "%" Then 	'it's a check state
				Control Set Check hDlg, i, Val(Parse$(tmp, $Tab, 2))

			End If

		Loop Until Eof(ff)
		Close #ff

	End If

	GetSettings hDlg

End Sub 'LoadSettings

'

Sub SaveSettings(hDlg As Dword)
Local ff  As Long
Local n   As Long
Local b   As Long
Local i   As Long
Local v   As Long
Local cx  As Long
Local cy  As Long
Local s   As String
Local t   As Asciz * 2

	If Len(Dir$($IniFile)) Then

		ff = FreeFile
		Open $IniFile For Binary As #ff
			Get$ #ff, Lof(ff), stg
			stg = RTrim$(stg, Any $CrLf)
		Close #ff

		Open $IniFile For Output As #ff
		For n = 1 To ParseCount(stg, $CrLf)
			tmp = Trim$(Parse$(stg, $CrLf, n))
			t = Left$(tmp, 1)
			i = Val(Parse$(tmp, "=", 2))		'get control ID

			If t = "@" Then 	'it's position coordinates
				If i < 1000 Then
					Dialog Get Loc hDlg To cx, cy
				Else
					Control Get Loc hDlg, i To cx, cy
				End If
				tmp = Parse$(tmp, $Tab, 1) & $Tab & Format$(cx) & $Tab & Format$(cy)

			ElseIf t = "$" Then 	'it's text
				Control Get Text hDlg, i To s	'get current setting
				tmp = Parse$(tmp, $Tab, 1) & $Tab & s

			ElseIf t = "%" Then 	'it's a check state
				tmp = Parse$(tmp, $Tab, 1) & $Tab & Format$(GetCheck(i))

			Else
				'do nothing
			End If

				Print# ff, tmp

		Next n
		Close #ff

	End If

End Sub 'SaveSettings

'
' Gets current settings from controls and
'puts them in the bit mask "Prefs".
' The CheckBox ID's were chosen so the bit
'values could be calculated from them.
'Be sure the bit numbers don't go past the
'end of the variable you store them in.
'Notice "GetCheck(i)" is enclosed by paren-
'theses so return values above 1 will be
'converted to 1.
Sub GetSettings(hDlg As Dword)
Local b   As Long
Local i   As Long

	Prefs = 0
	For i = %AddrChk To %MnemChk
		Bit Calc Prefs, (i - %AddrChk), GetCheck(i)
	Next i

End Sub 'GetSettings

'
